import 'dart:async';
import 'dart:convert';


import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';



class HomeScreen1 extends StatefulWidget {
  const HomeScreen1({Key? key}) : super(key: key);

  @override
  State<HomeScreen1> createState() => _HomeScreen1State();
}

class _HomeScreen1State extends State<HomeScreen1> {

  PageController pageController=PageController( initialPage: 0);
  Timer? timer;
  int _currentPage = 0;
  int _currentIndex=0;
  final ScrollController scrollController = ScrollController();
  List<dynamic> productImage = [
    'assets/product1.jpg',
    'assets/product2.jpg',
    'assets/product3.jpg',
    'assets/product4.jpg',
    'assets/product5.jpg',
    'assets/product6.jpg',
  ];
  List productName=['product1','product2','product3','product4','product5','product6'];
  List productPrice=['234','232','543','132','534','645'];
  List<dynamic> bannerImage = [
    'assets/banner1.jpg',
    'assets/banner2.jpg',
    'assets/banner3.jpg',
  ];




  @override
  void initState() {
    super.initState();
    timer=Timer.periodic(const Duration(seconds: 4), (Timer timer) {
      return setState(() {
        _currentPage++;
        pageController.animateToPage(
          _currentPage,
          duration: const Duration(milliseconds: 600),
          curve: Curves.fastEaseInToSlowEaseOut,
        );

      });
    });
  }

  @override
  void dispose() {
    scrollController.dispose();
    timer?.cancel();
    super.dispose();
  }




  @override
  Widget build(BuildContext context) {
    Size screenSize = MediaQuery.of(context).size;
    const myColor=Colors.teal;
    return  Scaffold(

      body: Padding(
          padding:  EdgeInsets.only(top: screenSize.height*.07),
          child: SingleChildScrollView(
            controller: scrollController,
            child: Stack(
              children: [
                Padding(
                  padding:  EdgeInsets.only(top: screenSize.height*.004),
                  child: Container(
                      width: double.maxFinite,
                      margin: const EdgeInsets.only(left: 10,top: 9,right: 10,bottom: 5),
                      height: 44,
                      decoration: BoxDecoration(
                          color: Colors.white,
                          borderRadius: BorderRadius.circular(20),
                          boxShadow: const [BoxShadow(
                              color: Colors.grey,
                              blurRadius: 4
                          )]
                      ),
                      child: TextFormField(
                        textInputAction: TextInputAction.search,
                        onFieldSubmitted: (text){
                          // Navigator.pushAndRemoveUntil(context, MaterialPageRoute(builder: (context)=>SearchScreen(search: text)), (route) => true);
                        },
                        decoration: const InputDecoration(
                            enabledBorder: OutlineInputBorder(
                                borderSide: BorderSide.none
                            ),
                            focusedBorder: OutlineInputBorder(
                                borderSide: BorderSide.none
                            ),
                            prefixIcon: Icon(Icons.search)
                        ),
                      ))
                ),
                Container(
                  margin: EdgeInsets.only(top: screenSize.height*.05),
                  height: 230,
                  width: double.maxFinite,
                  child: PageView.builder(
                      scrollBehavior: const ScrollBehavior(),
                      controller: pageController,
                      onPageChanged: (index){
                        setState(() {
                          _currentIndex=index %bannerImage.length;
                        });
                      },
                      itemBuilder: (BuildContext context, int index){
                        if(bannerImage.isEmpty){
                          return  LinearProgressIndicator(
                            color: Colors.grey.shade100,
                            backgroundColor: Colors.white54,
                          );
                        }else {
                          return

                              Container(
                                height: 220,
                                width: screenSize.width,
                                decoration: BoxDecoration(
                                  image: DecorationImage(image: AssetImage('${bannerImage[index % bannerImage.length]}'))
                                )
                              );
                        }
                      }
                  ),
                ),
                Padding(
                  padding:  EdgeInsets.only(top: screenSize.height*.28),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      for(var i=0; i<bannerImage.length; i++)
                        DotIndicator(_currentIndex==i)
                    ],),
                ),
                Container(
                  width: screenSize.width,
                  alignment: Alignment.center,
                  padding:  EdgeInsets.only(top: screenSize.height*.32),
                  child:

                  const Text('Featured Products',style: TextStyle(
                      fontSize: 20,
                      fontWeight: FontWeight.bold
                  ),),
                ),
                Padding(
                  padding: EdgeInsets.only(top: screenSize.height*.32),
                  child: Padding(
                          padding: const EdgeInsets.only(left: 12,right: 12),
                          child: GridView.builder(
                              cacheExtent: 20,
                              gridDelegate: const SliverGridDelegateWithMaxCrossAxisExtent(
                                  maxCrossAxisExtent: 250,
                                  childAspectRatio: 2 / 3.6,
                                  crossAxisSpacing: 15,
                                  mainAxisSpacing: 15),
                              physics: const ScrollPhysics(),
                              shrinkWrap: true,
                              itemCount: productImage.length??0,
                              itemBuilder: (BuildContext context, int index) {
                                if (productImage.isEmpty) {
                                  return  Center(
                                    child: LinearProgressIndicator(
                                      minHeight: double.infinity,
                                      color: Colors.grey.shade100,
                                      backgroundColor: Colors.white54,
                                    ),
                                  );
                                } else {

                                  return Container(
                                    decoration: BoxDecoration(
                                      color: Colors.white,
                                      borderRadius: BorderRadius.circular(10),
                                      boxShadow: const [BoxShadow(
                                          offset: Offset(1,3),
                                          color: Colors.grey,
                                          blurRadius: 10
                                      )
                                      ],
                                    ),
                                    child: GestureDetector(
                                      onTap: () {
                                        // Navigator.of(context).pushAndRemoveUntil(
                                        //     CupertinoPageRoute(
                                        //         builder: (context) =>
                                        //             ProductDetails(product: product)),
                                        //         (route) => true);
                                      },
                                      child: Column(
                                        mainAxisAlignment: MainAxisAlignment.spaceAround,
                                        children: [
                                          Container(
                                            height: 150,
                                            margin: const EdgeInsets.only(top: 15),
                                            alignment: Alignment.center,
                                            child: Image(
                                                image: AssetImage('${productImage[index]}'),
                                                // fit: BoxFit.cover,
                                                width:double.infinity
                                            ),
                                          ),
                                          Container(
                                              margin: const EdgeInsets.only(top: 10),
                                              padding: const EdgeInsets.only( left: 10,right: 10),
                                              alignment: Alignment.centerLeft,
                                              child: Text('${productName[index]}',maxLines: 2,style: const TextStyle(fontSize: 18),)),
                                          Container(
                                              margin: const EdgeInsets.only(left: 10,right: 10,top: 10),
                                              alignment: Alignment.centerLeft,
                                              child: Text('\u0024${productPrice[index]}',style: const TextStyle(fontSize: 18),)
                                          ),
                                          Container(
                                            margin: const EdgeInsets.only(top: 10),
                                            padding: const EdgeInsets.symmetric(horizontal: 10),
                                            width: double.maxFinite/2,
                                            child: ElevatedButton(
                                                style: ElevatedButton.styleFrom(backgroundColor: myColor),
                                                onPressed: (){
                                                },
                                                child: const Text('Add to Cart')),
                                          )
                                        ],
                                      ),
                                    ),
                                  );
                                }
                              }),
                        )

                ),




              ],
            ),


            // Container(
            //   child: GridView.builder(
            //       itemBuilder: (context,index){
            //
            //       }, gridDelegate: null,),
            // )

          )
      ),

    );
  }


}

Widget DotIndicator(bool x){
  return Padding(
    padding: const EdgeInsets.all(8.0),
    child: Container(
      height: x? 12:8,
      width:  x? 12:8,
      decoration:   BoxDecoration(
          shape: BoxShape.circle,
          color: x? Colors.black: Colors.white70,
          boxShadow: [BoxShadow(
            blurRadius: 1,
            color: Colors.grey,
            spreadRadius: 1,
          )
          ]
      ),
    ),
  );
}



